import processing.core.*; 
import processing.xml.*; 

import processing.opengl.*; 
import ddf.minim.*; 
import ddf.minim.analysis.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class FLAMENCO extends PApplet {



// Dec 2008 
// http://www.abandonedart.org
// http://www.zenbullets.com
//
// with lots of thanks to Erik Natzke (obviously)
// http://jot.eriknatzke.com/
//
// and James Alliban, who saved me the job of doing the conversion
// http://jamesalliban.wordpress.com/2008/12/04/2d-ribbons/
//
//
// This work is licensed under a Creative Commons 3.0 License.
// (Attribution - NonCommerical - ShareAlike)
// http://creativecommons.org/licenses/by-nc-sa/3.0/
// 
// This basically means, you are free to use it as long as you:
// 1. give http://www.zenbullets.com a credit
// 2. don't use it for commercial gain
// 3. share anything you create with it in the same way I have
//
// These conditions can be waived if you want to do something groovy with it 
// though, so feel free to email me via http://www.zenbullets.com


//================================= colour sampling

int numcols = 600; // 30x20
int[] colArr = new int[numcols];

public void sampleColour() {
  PImage img;
  img = loadImage("tricolpalette.jpg");
  image(img,0,0);
  int count = 0;
  for (int x=0; x < img.width; x++){
    for (int y=0; y < img.height; y++) {
      if (count < numcols) {
        int c = get(x,y);
        colArr[count] = c;
      }
      count++;
    }
  }  
}

//================================= global vars

int _numRibbons = 2;
int _numParticles = 35;
float _randomness = .20f;
RibbonManager ribbonManager;

float ro;
float orbitRad = 100;



float _a, _b, centrex1, centrey1,centrex2, centrey2, _x, _y;
float[]centreX = {centrex1, centrex2};
float[]centreY = {centrey1, centrey2};
float _noiseoff;
int _angle;

//================================= init




Minim minim;
AudioInput in;
AudioPlayer player;
FFT fft;
FFT fftLin;

int highest = 0;
int h = 0;
int amp = 0;
int fact = 5;

BeatDetect beat;
BeatListener bl;
float kickSize, snareSize, hatSize;
float amplitude;
boolean came=false;

public void setup() {
  size(1024, 768,OPENGL);
  hint( ENABLE_OPENGL_4X_SMOOTH );
  smooth(); 
  //frameRate(30);
  background(0);
  
  //sampleColour();
  clearBackground();
  
  centrex1 = 200;
  centrey1 = 600;
  centrex2 = 800;
  centrey2 = 550;
centreX = new float[2];
centreY = new float[2];
centreX[0] = centrex1;
centreX[1] = centrex2;
centreY[0] = centrey1;

centreY[1] = centrey2;


   minim = new Minim(this);
  in = minim.getLineIn(Minim.STEREO, 2048, 44100);
  String path = dataPath("");//
   player = minim.loadFile("flamenco.mp3", 2048);
   player.play();
 
 
  fft = new FFT(in.mix.size(), 44100);
 fftLin = new FFT(in.mix.size(),44100);//travailler en live avec l'entr\u00e9e son
  // fftLin = new FFT(player.bufferSize(), player.sampleRate());
  // int nbre = 22400/128;
  fftLin.linAverages(128);
   beat = new BeatDetect();
    kickSize = snareSize = 60;
  hatSize= 60;
   beat.setSensitivity(300);  

  
  restart();
}    

public void restart() {
  _noiseoff = random(1);
  _angle = 1; 
  _a = 30.5f;
  _b = _a + (noise(_noiseoff) * 1) - 0.5f;
  for (int i = 0; i< 2; i++){
  float posX = random(100,850);
  float posY = random(100, 600);
  ribbonManager = new RibbonManager(_numRibbons, _numParticles, _randomness, X, Y);   
  ribbonManager.setRadiusMax(random(5,36));                 // default = 8
  ribbonManager.setRadiusDivide(random(5,20));              // default = 10
  ribbonManager.setGravity(.0f);                   // default = .03
  ribbonManager.setFriction(1.1f);                  // default = 1.1
  ribbonManager.setMaxDistance(40);               // default = 40
  ribbonManager.setDrag(2.5f);                      // default = 2
  ribbonManager.setDragFlare(.015f); 
}  // default = .008
  
}

public void clearBackground() {
background(255,0,0);
  noStroke();
  fill(245,0,0,60-h);
  rectMode(CENTER);
 pushMatrix();
  translate(0,0,-1000);
 rect(0,0,width*10, height*10);
 //came = false;
 popMatrix();
}


//================================= frame loop

public void draw() {
   //ambientLight(190, 102, 220);
 // if(beat.isKick()){
  //directionalLight(237, 230, 16, 0, 0, 1);
  if(player.isPlaying()== false){
    
    clearBackground();
    exit();
  }
    beat.detect(player.mix);
 if ( beat.isOnset() ){
 //println("tempsfort==========");
 restart();
//     background(16,134,17);
//      //tempsFort = true;
 }
 if( h>15){
  clearBackground();
  }
  noStroke();
   ro = (TWO_PI*millis()/40000);
 float val1 = cos(ro)*orbitRad;
// println(h);
if(keyPressed ==true || h>40){
   came = false;
  // println("cameraOff");
 }else{
came =true;
}
 if(came){
   println("camera");
   pushMatrix();
  // camera(width/2.0, height/2.0, -3700+(h*200), width/2.0, height/2.0, 0, 0, 1, 0);
   popMatrix();
 }
   
    fft.forward(in.left);//travailler en live
   frameRate(10+h);

  for (int i = 0; i < width; i++) {
    float amplitude = 0;
    for (int j = 0; j <fftLin.avgSize(); j++) { 
      amplitude += fft.getFreq(i * 8 + j);

      amp = (int) amplitude;

      if (amplitude>highest) {
        highest= (int)amplitude;
      }
      if (amplitude >0) {

        float h1 = map(amp, 0, highest, 0, height-10);
        h = (int)h1*fact;
      }
    }
  }
  
  
  for (int i = 0; i<2; i++){
  float newx = sin(_a + radians(_angle) + PI / 2) * centreX[i];  
  float newy = sin(_b + radians(_angle)) * centreY[i]; 
  
  _angle += (random(180) - 90);
  if (_angle > 360) { _angle = 0; }
  if (_angle < 0) { _angle = 360; }
 // pushMatrix();
 float coeff = map(h, 0,100, 0,400);
//                               
constrain(coeff,200,400);
 println(coeff);
  translate(centreX[i], centreY[i],-500 +coeff);
  rotateZ(_angle);
 // popMatrix();
  ribbonManager.update(newx* 0.5f, newy*0.5f);
 // came = true;
  //println(centreX[0]);
  }
}



//================================= interaction

public void mousePressed() { 
  restart();
}



//================================= objects
// modified from original code by http://jamesalliban.wordpress.com/


//======== manager

class RibbonManager {
  int _numRibbons;
  int _numParticles;
  float _randomness;
  float posX;
  float posY;
  Ribbon[] ribbons; 
int ribbonColour;  // ribbon array
  
  RibbonManager(int _numRibbons, int _numParticles, float _randomness, float poX, float poY) {
    this._numRibbons = _numRibbons;
    this._numParticles = _numParticles;
    this._randomness = _randomness;
    this. posX = poX;
    this.posY = poY;
    init();
  }
  
  public void init() {
    addRibbon();
  }

  public void addRibbon() {
    ribbons = new Ribbon[_numRibbons];
    for (int i = 0; i < _numRibbons; i++) {
      //color ribbonColour = colArr[int(random(numcols))];
      noStroke();
      if(i%2 == 0){
      ribbonColour = color(255,random(200, 255), 0);
      }else{
        ribbonColour = color(0,random(10,30), 0);
      }
      
      ribbons[i] = new Ribbon(_numParticles, ribbonColour, _randomness, posX, posY);
    }
  }
  
  public void update(float currX, float currY)  {
    for (int i = 0; i < _numRibbons; i++) {
      float randX = currX;
      float randY = currY;
      
      ribbons[i].update(randX, randY);
    }
  }
  
  public void setRadiusMax(float value) { for (int i = 0; i < _numRibbons; i++) { ribbons[i].radiusMax = value; } }
  public void setRadiusDivide(float value) { for (int i = 0; i < _numRibbons; i++) { ribbons[i].radiusDivide = value; } }
  public void setGravity(float value) { for (int i = 0; i < _numRibbons; i++) { ribbons[i].gravity = value; } }
  public void setFriction(float value) { for (int i = 0; i < _numRibbons; i++) { ribbons[i].friction = value; } }
  public void setMaxDistance(int value) { for (int i = 0; i < _numRibbons; i++) { ribbons[i].maxDistance = value; } }
  public void setDrag(float value) { for (int i = 0; i < _numRibbons; i++) { ribbons[i].drag = value; } }
  public void setDragFlare(float value) { for (int i = 0; i < _numRibbons; i++) { ribbons[i].dragFlare = value; } }
}


//======== ribbon  

class Ribbon {
  int _numRibbons;
  float _randomness;
  int _numParticles;         // length of the Particle Array (max number of points)
  int particlesAssigned = 0;        // current amount of particles currently in the Particle array                                
  float radiusMax = random(24,72);              // maximum width of ribbon
  float radiusDivide = 10;          // distance between current and next point / this = radius for first half of the ribbon
  float gravity = .03f;              // gravity applied to each particle
  float friction = 1.1f;             // friction applied to the gravity of each particle
  int maxDistance = 40;             // if the distance between particles is larger than this the drag comes into effect
  float drag = 2;                   // if distance goes above maxDistance - the points begin to grag. high numbers = less drag
  float dragFlare = .008f;           // degree to which the drag makes the ribbon flare out
  RibbonParticle[] particles;       // particle array
  int ribbonColor;
  float posX;
  float posY;
  
  Ribbon(int _numParticles, int ribbonColor, float _randomness,float px, float py) {
    this._numParticles = _numParticles;
    this.ribbonColor = ribbonColor;
    this._randomness = _randomness;
    this.posX =px;
    this.posY = py;
    init();
  }
  
  public void init() {
    particles = new RibbonParticle[_numParticles];
  }
  
  public void update(float randX, float randY){
    addParticle(randX, randY);
    drawCurve();
  }
  
  public void addParticle(float randX, float randY) {
    if(particlesAssigned == _numParticles) {
      for (int i = 1; i < _numParticles; i++) {
        particles[i-1] = particles[i];
      }
      particles[_numParticles - 1] = new RibbonParticle(_randomness, this);
      particles[_numParticles - 1].px = randX;
      particles[_numParticles - 1].py = randY;
      return;
    } else {
      particles[particlesAssigned] = new RibbonParticle(_randomness, this);
      particles[particlesAssigned].px = randX;
      particles[particlesAssigned].py = randY;
      ++particlesAssigned;
    }
    if (particlesAssigned > _numParticles) ++particlesAssigned;
  }
  
  public void drawCurve() {
    smooth();
    for (int i = 1; i < particlesAssigned - 1; i++) {
      RibbonParticle p = particles[i];
      p.calculateParticles(particles[i-1], particles[i+1], _numParticles, i);
    }

    //fill(30);
    noStroke();
    for (int i = particlesAssigned - 3; i > 1 - 1; i--) {
      RibbonParticle p = particles[i];
      RibbonParticle pm1 = particles[i-1];
      fill(ribbonColor, 255);
      if (i < particlesAssigned-3) {
        
        beginShape();
        noStroke();
        vertex(p.lcx2, p.lcy2);
        bezierVertex(p.leftPX, p.leftPY, pm1.lcx2, pm1.lcy2, pm1.lcx2, pm1.lcy2);
        vertex(pm1.rcx2, pm1.rcy2);
        bezierVertex(p.rightPX, p.rightPY, p.rcx2, p.rcy2, p.rcx2, p.rcy2);
        vertex(p.lcx2, p.lcy2);
        endShape();
      }
    }
  }
}


//======== particle 

class RibbonParticle {
  float px, py;                                       // x and y position of particle (this is the bexier point)
  float xSpeed, ySpeed = 0;                           // speed of the x and y positions
  float cx1, cy1, cx2, cy2;                           // the avarage x and y positions between px and py and the points of the surrounding Particles
  float leftPX, leftPY, rightPX, rightPY;             // the x and y points of that determine the thickness of this segment
  float lpx, lpy, rpx, rpy;                           // the x and y points of the outer bezier points
  float lcx1, lcy1, lcx2, lcy2;                       // the avarage x and y positions between leftPX and leftPX and the left points of the surrounding Particles
  float rcx1, rcy1, rcx2, rcy2;                       // the avarage x and y positions between rightPX and rightPX and the right points of the surrounding Particles
  float radius;                                       // thickness of current particle
  float _randomness;
  Ribbon ribbon;
  
  RibbonParticle(float _randomness, Ribbon ribbon) {
    this._randomness = _randomness;
    this.ribbon = ribbon;
  }
  
  public void calculateParticles(RibbonParticle pMinus1, RibbonParticle pPlus1, int particleMax, int i) {
    float div = 2;
    cx1 = (pMinus1.px + px) / div;
    cy1 = (pMinus1.py + py) / div;
    cx2 = (pPlus1.px + px) / div;
    cy2 = (pPlus1.py + py) / div;

    // calculate radians (direction of next point)
    float dx = cx2 - cx1;
    float dy = cy2 - cy1;

    float pRadians = atan2(dy, dx);

    float distance = sqrt(dx*dx + dy*dy);

    if (distance > ribbon.maxDistance) {
      float oldX = px;
      float oldY = py;
      px = px + ((ribbon.maxDistance/ribbon.drag) * cos(pRadians));
      py = py + ((ribbon.maxDistance/ribbon.drag) * sin(pRadians));
      xSpeed += (px - oldX) * ribbon.dragFlare;
      ySpeed += (py - oldY) * ribbon.dragFlare;
    }
    
    ySpeed += ribbon.gravity;
    xSpeed *= ribbon.friction;
    ySpeed *= ribbon.friction;
    px += xSpeed + random(.3f);
    py += ySpeed + random(.3f);
    
    float randX = ((_randomness / 2) - random(_randomness)) * distance;
    float randY = ((_randomness / 2) - random(_randomness)) * distance;
    px += randX;
    py += randY;
    
    //float radius = distance / 2;
    //if (radius > radiusMax) radius = ribbon.radiusMax;
    
    if (i > particleMax / 2) {
      radius = distance / ribbon.radiusDivide;
    } else {
      radius = pPlus1.radius * .9f;
    }
    
    if (radius > ribbon.radiusMax) radius = ribbon.radiusMax;
    if (i == particleMax - 2 || i == 1) {
      if (radius > 1) radius = 1;
    }

    // calculate the positions of the particles relating to thickness
    leftPX = px + cos(pRadians + (HALF_PI * 3)) * radius;
    leftPY = py + sin(pRadians + (HALF_PI * 3)) * radius;
    rightPX = px + cos(pRadians + HALF_PI) * radius;
    rightPY = py + sin(pRadians + HALF_PI) * radius;

    // left and right points of current particle
    lpx = (pMinus1.lpx + lpx) / div;
    lpy = (pMinus1.lpy + lpy) / div;
    rpx = (pPlus1.rpx + rpx) / div;
    rpy = (pPlus1.rpy + rpy) / div;

    // left and right points of previous particle
    lcx1 = (pMinus1.leftPX + leftPX) / div;
    lcy1 = (pMinus1.leftPY + leftPY) / div;
    rcx1 = (pMinus1.rightPX + rightPX) / div;
    rcy1 = (pMinus1.rightPY + rightPY) / div;

    // left and right points of next particle
    lcx2 = (pPlus1.leftPX + leftPX) / div;
    lcy2 = (pPlus1.leftPY + leftPY) / div;
    rcx2 = (pPlus1.rightPX + rightPX) / div;
    rcy2 = (pPlus1.rightPY + rightPY) / div;
  }
}

class BeatListener implements AudioListener
{
  private BeatDetect beat;
  private AudioInput source;
  
  BeatListener(BeatDetect beat, AudioInput source)
  {
    this.source = source;
    this.source.addListener(this);
    this.beat = beat;
  }
  
  public void samples(float[] samps)
  {
    beat.detect(source.mix);
  }
  
  public void samples(float[] sampsL, float[] sampsR)
  {
    beat.detect(source.mix);
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--present", "--bgcolor=#666666", "--stop-color=#cccccc", "FLAMENCO" });
  }
}
